﻿Imports System.ComponentModel

' COPIED FROM SILVERLIGHTCONTRIB Project for simplicity
Namespace DataServices

  ''' <summary>
  ''' Base class for DataService Data Contract classes to implement 
  ''' base functionality that is needed like INotifyPropertyChanged.  
  ''' Add the base class in the partial class to add the implementation.
  ''' </summary>
  Public MustInherit Class DataServiceEntityBase
    Implements INotifyPropertyChanged
    ''' <summary>
    ''' The handler for the registrants of the interface's event 
    ''' </summary>
    Private Event _propertyChangedHandler As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    ''' <summary>
    ''' Allow inheritors to fire the event more simply.
    ''' </summary>
    ''' <param name="propertyName"></param>
    Protected Sub FirePropertyChanged(ByVal propertyName As String)
      RaiseEvent _propertyChangedHandler(Me, New PropertyChangedEventArgs(propertyName))
    End Sub

    ''' <summary>
    ''' The interface used to notify changes on the entity.
    ''' </summary>
    Private Custom Event PropertyChanged As PropertyChangedEventHandler
      AddHandler(ByVal value As PropertyChangedEventHandler)
        AddHandler _propertyChangedHandler, value
      End AddHandler
      RemoveHandler(ByVal value As PropertyChangedEventHandler)
        RemoveHandler _propertyChangedHandler, value
      End RemoveHandler
      RaiseEvent(ByVal sender As System.Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs)
      End RaiseEvent
    End Event
  End Class

End Namespace
