﻿Imports MVVM.Client.Data
Imports System.Windows.Browser

Namespace Views

  Partial Public Class GameView
    Inherits UserControl

    Private WithEvents viewModel As GamesViewModel

    Public Sub New()

      InitializeComponent()

      ' Wire up the View Model
      viewModel = TryCast(Resources("TheViewModel"), GamesViewModel)

    End Sub

    Private Sub LoadGames(ByVal genre As String)
      loadingBar.Visibility = Visibility.Visible
      If genre = "(All)" Then
        viewModel.LoadGames()
      Else
        viewModel.LoadGamesByGenre(genre)
      End If

    End Sub

    Private Sub Page_Loaded(ByVal sender As Object, _
                            ByVal e As RoutedEventArgs) _
                            Handles Me.Loaded

      ' Setup the Genre Lists
      Dim genres() As String = {"(All)", "Action", "Adventure", "Compilations", _
                                "Family", "Fighting", "Music", "Platform", _
                                "Racing", "RPG", "Shooter", "Simulation", _
                                "Sports", "Strategy", "Xbox Originals", _
                                "Xbox LIVE Arcade"}

      genreComboBox.ItemsSource = genres
      genreComboBox.SelectedIndex = 4

    End Sub

    Private Sub viewModel_LoadComplete(ByVal sender As Object, _
                                       ByVal e As EventArgs) _
                                       Handles viewModel.LoadComplete

      loadingBar.Visibility = Visibility.Collapsed

    End Sub

    Private Sub viewModel_ErrorLoading(ByVal sender As Object, _
                                       ByVal e As EventArgs) _
                                       Handles viewModel.ErrorLoading

      loadingBar.Visibility = Visibility.Collapsed
      HtmlPage.Window.Alert("Error occurred while loading data")

    End Sub

    Private Sub genreComboBox_SelectionChanged(ByVal sender As Object, _
                                              ByVal e As SelectionChangedEventArgs) _
                                              Handles genreComboBox.SelectionChanged

      Dim item As String = TryCast(genreComboBox.SelectedItem, String)

      If item IsNot Nothing Then
        LoadGames(item)
      End If

    End Sub

    ' Wire up a selection changed since Element Binding isn't supported yet
    Private Sub gameListBox_SelectionChanged(ByVal sender As Object, _
                                             ByVal e As SelectionChangedEventArgs) _
                                             Handles gameListBox.SelectionChanged

      detailGrid.DataContext = gameListBox.SelectedItem
      detailGrid.Visibility = If(gameListBox.SelectedItem Is Nothing, Visibility.Collapsed, Visibility.Visible)

    End Sub
  End Class
End Namespace